#ifndef __AAP_ASA_H__
#define __AAP_ASA_H__

#include "tim.h"
#include "net.h"
#include "cfg.h"
#include "aap.h"
#include "net_socket.h"
#include "addr_range.h"
#include "aap_msg.h"



/**  
 *  Prefix Coordinators periodically announce the set of multicast
 *  addresses and lifetimes available for allocation within the domain
 *  using the Address Space Announce (ASA) message.
 */

typedef struct aap_asa_ aap_asa;

struct aap_asa_ {

    net *n;
    net_socket *ns;
    tim *t;
    cfg *c;
    aap *aap;
    int last_exp_tim;
    int rseq, mseq;
  
    int (*send)(aap_asa *a, list *ranges);
    void (*delete)(aap_asa *a);
    
};

aap_asa *aap_asa_new(net *, net_socket *ns, tim *, cfg *, aap *aap, int rseq);

int aap_asa_receive(aap *aap, aap_msg *msg);

#endif
