#ifndef __AREC_H__
#define __AREC_H__

#include "tim.h"
#include "cfg.h"
#include "addr_range.h"
#include "allocation.h"
#include "list.h"
#include "plist.h"
#include "ana_req.h"

typedef struct arec_ arec;

struct arec_ {
 
    cfg *cfg;
    tim *tim;

    list *cur_claims;
    plist *cur_allocs;
    list *own_allocs;
    plist *end_allocs;
    
    plist *asa_ranges;
    plist *asa_end;

    list *ana_reqs;

    unsigned int next_asa_end_time;
    tim_id_t next_asa_end_tim_id;
    
    unsigned int next_end_time;
    tim_id_t next_end_tim_id;
    allocation *next_end_alloc;

    int no_asas;

    void (*insert_ana)(arec *arec, ana_req *ana_r);
    
    void (*insert)(arec *arec, allocation *alloc);
    void (*insert_asa)(arec *arec, addr_range *ar);
    void (*insert_claim)(arec *arec, addr_range *ar);
  
    void (*insert_own)(arec *arec, allocation *alloc);
    void (*remove)(arec *arec, allocation *alloc);
    void (*remove_claim)(arec *arec, addr_range *ar);
    list *(*overlap)(arec *arec, addr_range *ar);
    int (*in_use)(arec *arec, addr_range *ar);
    list *(*overlap_claims)(arec *arec, addr_range *ar);
    addr_range *(*sel_addr)(arec *arec, int num, unsigned int end_time);

    list *(*allocations)(arec *arec);
    int (*is_own)(arec *arec, addr_range *ar);

    void (*set_asa_exp_timer)(arec *arec, int time);
 
  
};

arec *arec_new(cfg *c, tim *t, addr_range *scope);



#endif

