#ifndef __CLAIMER_H__
#define __CLAIMER_H__

#include "net.h"
#include "net_socket.h"
#include "tim.h"
#include "cfg.h"
#include "allocation.h"
#include "aap.h"
#include "aap_aiu.h"
#include "aap_aclm.h"


typedef struct claimer_ claimer;

struct claimer_ {

  net *n;
  net_socket *ns;
  tim *t;
  cfg *cfg;
  aap *aap;

  int numallocs;
  unsigned int end_time;
  
  allocation *alloc;

  aap_callback_func f;
  void *obj;
  
  aap_aclm *aclm;
  aap_aiu *aiu;

  int active;
  
  tim_id_t claim_timer, resend_timer, defense_timer;
  unsigned int last_interval;

  void (* retry)(claimer *clm);
  void (* retry_in)(claimer *clm, unsigned int seconds);
  void (* delete)(claimer *clm);
  void (* cancel)(claimer *clm);
  void (* claim)(claimer *clm);
  int (* is_active)(claimer *clm);
  addr_range *(* range)(claimer *clm);
};

claimer *claimer_new(aap *aap, int numallocs, unsigned int end_time,
		     aap_callback_func f, void *obj);

#endif
